#include<stdio.h>
#define MAXLEN 100

   typedef struct {
      int len;
      char element[MAXLEN];
   } olist;

olist init()
   {
      olist L;
      L.len = 0;
      return L;
   }

void print(olist L)
   {
      int i;

      for(i = 0; i < L.len; ++i) printf("%c", L.element[i]);
   }

olist insert(olist L , char ch , int pos)
   {
      int i;

      if ((pos < 0) || (pos > L.len)) {
         fprintf(stderr, "insert: Invalid index %d\n", pos);
         return L;
      }
      if (L.len == MAXLEN) {
         fprintf(stderr, "insert: List already full\n");
         return L;
      }
      for (i = L.len; i > pos; --i) L.element[i] = L.element[i-1];
      L.element[pos] = ch;
      ++L.len;
      return L;
   }

olist delete(olist L, int pos)
   {
      int i;

      if ((pos < 0) || (pos >= L.len)) {
         fprintf(stderr, "delete: Invalid index %d\n", pos);
         return L;
      }
      for (i = pos; i <= L.len - 2; ++i) L.element[i] = L.element[i+1];
      --L.len;
      return L;
   }



main()
{
 olist L;
 L=init();
 L=insert(L,'a',0);
 print(L);
 printf("\n");
 L=insert(L,'b',0);
 print(L);   
 printf("\n");
 L=insert(L,'c',2);
 print(L);
 printf("\n");
 L=delete(L,5);
 print(L);
 L=delete(L,2);
 print(L);
}
