#include<stdio.h>
#include<malloc.h>

typedef struct list{
    char value;
    struct list *next;
}node;

typedef node* olist; 

olist init()
{
 olist L;
 L=(olist)malloc(sizeof(node));
 L->value='\0';
 L->next=NULL;
 return(L); 
}

void print(olist L)
{
 node *p;
 p=L->next;
 while(p!=NULL)
 {
   printf("%c",p->value);
   p=p->next;
 }
 printf("\n");
}

olist insert(olist L, char ch, int pos)
{
 int i;
 node *p;
 node *t;
 
 if(pos<0)
  {
    fprintf(stderr,"insert: Error in index\n");
    return(L);
  }
  p=L;
  i=0;
  while(i<pos)
  {
    p=p->next;
    if(p==NULL){
      fprintf(stderr,"insert: invalid index\n");
      return(L);
     }
    i++; 
  }
  t=(node *)malloc(sizeof(node));
  t->value=ch;
  t->next=p->next;
  p->next=t;
  return(L);
}

olist delete(olist L, int pos)
{
 int i=0;
 node *p;
 if(pos<0){
   fprintf(stderr,"delete: invalid index\n");
   return(L);
  }
 p=L;
 i=0;

 while(i<pos)
 {
  p=p->next;
    if(p->next==NULL)
    {
      fprintf(stderr,"delete: invalid index\n");
      return(L);
    }
  i++;
  }
  
p->next=p->next->next;   
return(L);
}

void reverse(olist L)
{
 node *temp;
 node *temp1;
 node *temp2;
 temp=L;temp1=temp->next;temp2=temp1->next;
 temp->next->next=NULL;

 while(temp2!=NULL)
 {
  temp=temp1;
  temp1=temp2;
  temp2=temp1->next;
  temp1->next=temp;
 }
L->next=temp1;
}




main()
{
 olist L;
 L=init();
 print(L);
 insert(L,'a',0);
 print(L);
 insert(L,'b',1);
 print(L);
 insert(L,'c',1);
 print(L);
 printf("\nReversing\n");
 reverse(L);
 print(L);
 delete(L,3);
 print(L);
 delete(L,2);
 print(L);
 delete(L,0);
 print(L);
}
