#include <stdio.h>
#include <malloc.h>

   #define ROWSIZE 5
   #define COLSIZE 5

   int A[ROWSIZE][COLSIZE];
   int (*B)[COLSIZE];
   int *C[ROWSIZE];
   int **D;

   int main ()
   {
      int i, j;

      printf("\nArray A\n");
      printf("sizeof(*A) = %d\n",sizeof(*A));
      i=0;
      printf("A[i]=%4d, A=%4d\n",(int)A[i], (int)A);

      printf("                        j=0   j=1   j=2   j=3   j=4\n");
      printf("                    +-------------------------------+\n");
      for (i=0; i<ROWSIZE; ++i) {
         printf("A[%d] = %4d :  i=%d  |", i, (int)A[i]-(int)A, i);
         for (j=0; j<COLSIZE; ++j)
            printf("%6d", (int)(&A[i][j])-(int)A);
         printf(" |\n");
      }
      printf("                    +-------------------------------+\n");
   
     printf("\nArray B\n");
     B=(int (*)[COLSIZE])malloc(ROWSIZE * sizeof(int [COLSIZE]));

     printf("sizeof(*B) = %d\n",sizeof(*B));
     i=0;
     printf("B[i]=%4d, B=%4d\n",(int)B[i], (int)B);

      printf("                        j=0   j=1   j=2   j=3   j=4\n");
      printf("                    +-------------------------------+\n");
      for (i=0; i<ROWSIZE; ++i){
           printf("B[%d]=%4d ", i, (int)(&B[i]));
        for(j=0;j<COLSIZE;++j)
             printf("%6d ",(int)(&B[i][j])-(int)B);
        printf(" |\n");
        printf("\n");
      }
    printf("                    +-------------------------------+\n");

     printf("\nArray C\n");
     for (i=0; i<ROWSIZE; ++i)
         C[i] = (int *)malloc(COLSIZE * sizeof(int));
     printf("sizeof(*C) = %d\n",sizeof(*C));
     i=0;
     printf("C[i]=%4d, C=%4d\n",(int)C[i], (int)C);

      printf("                        j=0   j=1   j=2   j=3   j=4\n");
      printf("                    +-------------------------------+\n");
      for (i=0; i<ROWSIZE; ++i){
           printf("C[%d]=%4d ", i, (int)(&C[i]));
     
         for (j=0; j<COLSIZE; ++j)
             printf("%6d ",(int)(&C[i][j])-(int)C);
         printf(" |\n");
         printf("\n");
      }
      printf("                    +-------------------------------+\n");

     printf("\nArray D\n");
     D=(int **)malloc(ROWSIZE * sizeof(int *));
     for(i=0;i<COLSIZE;i++)
        D[i]=(int *)malloc(COLSIZE*sizeof(int));
          
     printf("sizeof(*D) = %d\n",sizeof(*D));
     i=0;
     printf("D[i]=%4d, D=%4d\n",(int)D[i], (int)D);

      printf("                        j=0   j=1   j=2   j=3   j=4\n");
      printf("                    +-------------------------------+\n");
      for (i=0; i<ROWSIZE; ++i){
           printf("D[%d]=%4d ", i, (int)(&D[i]));
        for(j=0;j<COLSIZE;++j)
             printf("%6d ",(int)(&D[i][j])-(int)D);
        printf(" |\n");
        printf("\n");
      }
    printf("                    +-------------------------------+\n");

      
}
